/**********************************************************************/
//FILE:rgbycc.c                                                       */
//DATE:2006/8/4                                                       */
//example for FP-Fixer                                                */
/*Please type `Fpfix -all_*** -arg rgbdata.data rgbycc.c' on console. */
/**********************************************************************/

//
// FP-Fixer v2.08.xx ̓f@\ׂ̈̋Lq
// (1)͑ΏۂR[Ă֐ // fpfix mpdule fBNeBuLq
// (2)͑Ώۊ֐ input, output, inout̃fBNeBuLq
// (3)$FPFIX/evfunc/fpf_evfunc.tmpl JgɃRs[
//     Kvɉĕ]eύX


/*fixed module*/
void rgbycc_org(
    double r, double g, double b,
    double *y, double *cb, double *cr
)
{
    *y = 0.299    * r + 0.587   * g + 0.114   * b;
    *cb= -0.16874 * r - 0.33126 * g + 0.5     * b + 0x80;
    *cr= 0.5      * r - 0.41869 * g - 0.08131 * b + 0x80;

}

void yccrgb_org(
    double y,double cb,double cr,
    double *r,
    double *g,
    double *b
)
{
    *r = y + 1.402   * (cr - 0x80);
    *g = y - 0.34414 * (cb - 0x80) - 0.71414 * (cr - 0x80);
    *b = y + 1.772   * (cb - 0x80);

}

/*for simulation code*/
// (2) input, output, inout̃fBNeBut
void rgbycc(
    double r,double g,double b,
    double*y,   // fpfix output rate=1:m evfunc=cmpData
    double*cb,  // fpfix output rate=1:m evfunc=cmpData
    double*cr   // fpfix output rate=1:m evfunc=cmpData
)
{
    *y = 0.299    * r + 0.587   * g + 0.114   * b;
    *cb= -0.16874 * r - 0.33126 * g + 0.5     * b + 0x80;
    *cr= 0.5      * r - 0.41869 * g - 0.08131 * b + 0x80;

}

// (2) input, output, inout̃fBNeBut
void yccrgb(
    double y,double cb,double cr,
    double *r,  // fpfix output rate=1:m evfunc=cmpData
    double *g,  // fpfix output rate=1:m evfunc=cmpData
    double *b   // fpfix output rate=1:m evfunc=cmpData
)
{
    *r = y + 1.402   * (cr - 0x80);
    *g = y - 0.34414 * (cb - 0x80) - 0.71414 * (cr - 0x80);
    *b = y + 1.772   * (cb - 0x80);

}


#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double fpfix_error_rate=0.01;
//#define _DEBUG_

double getData(FILE*fp);
int errJudge(int errflg,int totaldata,double acceptrate);
int checkErr(double r,double g,double b,
         double out_r,double out_g,double out_b,
         double errate);

static int ng=0;

int main(int argc,char**argv)
{
    int i;
    double r,g,b;
    double y,cb,cr;
    double exp_y,exp_cb,exp_cr;
    double exp_r,exp_g,exp_b;
    double out_r,out_g,out_b;
    FILE*fp;
    int rr = 0;

    if(argc!=2){
        printf("usage: <input-data>\n");
        return -1;
    }

    fp=fopen(argv[1],"r");
    if(!fp){
       perror(argv[1]);
       return -1;
    }

    i=0;
    ng=0;
    while((r=getData(fp))>=0.0){
      g=getData(fp);
      if(g<0.0) break;
      b=getData(fp);
      if(b<0.0) break;

      // Ғl쐬iŒ菬_C]ׁ̈j
      rgbycc_org(r,g,b,&exp_y,&exp_cb,&exp_cr);
      yccrgb_org(exp_y,exp_cb,exp_cr,&exp_r,&exp_g,&exp_b);

      // (1)modulefBNeBu
      rgbycc(r,g,b,&y,&cb,&cr);                         // fpfix module

      // v2.08.xx ́A͎A]֐ō쐬邽evFunc͕sv
      // AAŒ菬_C]̈׍쐬Ēu
      // i]֐Ǝɍ쐬ꍇ́Argbycc_uevQƁj
      rr = checkErr(exp_y,exp_cb,exp_cr,y,cb,cr,fpfix_error_rate); //fpfix evFunc
      if( rr != 0 ){
        break;
      }

      // (1)modulefBNeBu
      yccrgb(exp_y,exp_cb,exp_cr,&out_r,&out_g,&out_b); // fpfix module

      rr = checkErr(exp_r,exp_g,exp_b,out_r,out_g,out_b,fpfix_error_rate); //fpfix evFunc
      if( rr != 0 ){
        break;
      }
      i++;
    }
    printf ( "total:%d ng:%d\n", i, ng );

    fclose ( fp );
    return rr;
}

double getData(FILE*fp)
{
    static char buf[1024];
    if(fgets(buf,1024,fp)==NULL) return -1.0;
    return atof(buf);
}

/*Evaluation function*/
int checkErr_detail ( char *rgb, double exp, double errate, double out )
{
   int flg=0;
   double fMax=0.0;
   double fMin=0.0;
   double fExp=0.0;
   double fOut=0.0;

#ifdef _DEBUG_
   char szMax[32];
   char szMin[32];
   char szExp[32];
   char szOut[32];
#endif

   if( fabs(exp) < 1 && fabs(out) < 1 ){
        exp = 0;
        out = 0;
    }

   fExp=exp;
   if ( fExp >= 0.0 ) {
     fMax=(fExp * (1.0 + errate));
     fMin=(fExp * (1.0 - errate));
   } else {
     fMax=(fExp * (1.0 - errate));
     fMin=(fExp * (1.0 + errate));
   }
   fOut=out;

   flg = ( (fOut > fMax) || (fMin > fOut) );

#ifdef _DEBUG_
   sprintf ( szExp, "%lf", fExp );
   sprintf ( szMax, "%lf", fMax );
   sprintf ( szMin, "%lf", fMin );
   sprintf ( szOut, "%lf", fOut );

   printf ( " %s : %s : e.%10s o.%10s r.%lf | %10s %2s %10s %2s %10s\n",
        rgb,
        (flg != 0) ? "ng" : "  ",
        szExp, szOut, errate,
        szMax,
        ((fMax >= fOut) ? ">=" : "<"),
        szOut,
        ((fOut >= fMin) ? ">=" : "<"),
        szMin );
#endif

   if ( flg != 0 ) {
     ng++;
   }

   return ( flg );
}

int checkErr(double r,double g,double b,
         double out_r,double out_g,double out_b,
         double errate)
{
   int flg=0;

   flg  = checkErr_detail ( "r", r, errate, out_r );
   flg |= checkErr_detail ( "g", g, errate, out_g );
   flg |= checkErr_detail ( "b", b, errate, out_b );

   return ( flg );
}


