/*
 * RCS info: $Source: $
 *           $Revision: $
 *           $Date: $
 *           $Author: $
 *
 * Copyright (c) 2012 ISHIZUE Design Automation Corp.
 */

/*============================================================================
 * 쐬F
 * 쐬ҁF
 * t@CFdsp_ecalc.h
 * Tv  FŒ菬_w\֐
 *==========================================================================*/

#ifndef __FPF_ECALC_
#define __FPF_ECALC_

#ifdef __FPF_ECALC_MAX_16BIT
#define _FPF_ECALC_INT_MASK       0xffffU
#define _FPF_ECALC_INT_SINBIT     0x8000
#else
#define _FPF_ECALC_INT_MASK       0xffffffffU
#define _FPF_ECALC_INT_SINBIT     0x80000000
#endif

#ifdef _FPF_ECALC_FUNC_LONGLONG
#ifdef __FPF_ECALC_16BIT
#define _FPF_ECALC_LONG_TYPE      long
#define _FPF_ECALC_ULONG_TYPE     unsigned long
#define _FPF_ECALC_LONG_MASK      0xffffffffLU
#define _FPF_ECALC_LONG_0x01      0x01LU
#define _FPF_ECALC_LONG_SINBIT    0x80000000L
#else
#define _FPF_ECALC_LONG_TYPE      long long
#define _FPF_ECALC_ULONG_TYPE     unsigned long long
#define _FPF_ECALC_LONG_MASK      0xffffffffffffffffLLU
#define _FPF_ECALC_LONG_0x01      0x01LLU
#define _FPF_ECALC_LONG_SINBIT    0x8000000000000000LL
#endif
#endif

//
// double ۂߏ
//

// ؎̂
static double _fpf_DoubleRndTranInt( double fi )
{
    int itmp;
    int sign = 0;

    if( fi < 0 ){
        sign = 1;
        fi = fi * -1;
    }

    itmp = (int)fi;

    if( sign == 1 ){
        itmp = itmp * -1;
    }
    return (double)itmp;
}

// 0̂Piľܓj
static double _fpf_DoubleRndRndInt( double fi )
{
    int itmp;

    if( fi >= 0 ){
        fi = (fi + 0.5);
    } else {
        fi = (fi - 0.5);
    }
    itmp = (int)fi;
    return (double)itmp;
}

// ۂ
static double _fpf_DoubleRndEvenInt( double fi )
{
    double fval, ival;
    int ft, it;
    int sign = 0;

    if( fi < 0 ){
        sign = 1;
        fi = fi * -1;
    }

//    fval = modf( fi, &ival );
    ival = (double)(int)fi;
    fval = fi - ival;
    ft = (int)(fval * 2);
    it = (int)ival;
    if( ft & 0x01 ){
        ival += 1;
        if( fval == 0.5 && !(it & 0x01) ){
            ival -= 1;
        }
    }
    fi = ival;
    if( sign == 1 ){
        fi = fi * -1;
    }
    return fi;
}

// ceil
static double _fpf_DoubleRndCeilingInt( double fi )
{
    double dtmp;
    int itmp;

    dtmp = fi;
    itmp = (int)fi;

    dtmp = dtmp - itmp;
    if( dtmp != 0 ){
        itmp += 1;
    }
    
    return (double)itmp;
}

// floor
static double _fpf_DoubleRndFloorInt( double fi )
{
    int itmp;

    itmp = (int)fi;
    return (double)itmp;
}


//
// doubleɕϊ
//
static double _fpf_to_double_int( int fi, int ec_mode, int f_w, int ec_w )
{
    double dfi = fi;

    if( ec_mode == 2 ){
        dfi = dfi * (1U << ec_w );
    } else {
        dfi = dfi / (1U << f_w);
        dfi = dfi / (1U << ec_w);
    }
    return dfi;
}

static float _fpf_to_float_int( int fi, int ec_mode, int f_w, int ec_w )
{
    float dfi = fi;

    if( ec_mode == 2 ){
        dfi = dfi * (1U << ec_w );
    } else {
        dfi = dfi / (1U << f_w);
        dfi = dfi / (1U << ec_w);
    }
    return dfi;
}

//
// doubleŒ菬_֕ϊ
//
static int _fpf_to_fixed_int(
        double fi, int ec_mode, int f_w, int ec_w, int rnd_mode )
{
    if( ec_mode == 2 ){
        fi = fi / (1U << ec_w);
        return (int)fi;
    }

    fi = fi * (1U << ec_w);
    fi = fi * (1U << f_w);

    if( rnd_mode == 0 ){
        // ؎̂
        fi = _fpf_DoubleRndTranInt( fi );
    } else if( rnd_mode == 1 ){
        // 0̂P
        fi = _fpf_DoubleRndRndInt( fi );
    } else if( rnd_mode == 2 ){
        // ۂ
        fi = _fpf_DoubleRndEvenInt( fi );
    } else if( rnd_mode == 3 ){
        fi = _fpf_DoubleRndCeilingInt( fi );
    } else {
        fi = _fpf_DoubleRndFloorInt( fi );
    }
    return (int)fi;
}


//
//
//

#ifdef _FPF_ECALC_FUNC_LONGLONG

// ؎̂
static double _fpf_DoubleRndTranLong( double fi )
{
    _FPF_ECALC_LONG_TYPE itmp;
    int sign = 0;

    if( fi < 0 ){
        sign = 1;
        fi = fi * -1;
    }

    itmp = (_FPF_ECALC_LONG_TYPE)fi;

    if( sign == 1 ){
        itmp = itmp * -1;
    }
    return (double)itmp;
}

// 0̂Piľܓj
static double _fpf_DoubleRndRndLong( double fi )
{
    _FPF_ECALC_LONG_TYPE itmp;

    if( fi >= 0 ){
        fi = (fi + 0.5);
    } else {
        fi = (fi - 0.5);
    }
    itmp = (_FPF_ECALC_LONG_TYPE)fi;
    return (double)itmp;
}

// ۂ
static double _fpf_DoubleRndEvenLong( double fi )
{
    double fval, ival;
    _FPF_ECALC_LONG_TYPE ft, it;
    int sign = 0;

    if( fi < 0 ){
        sign = 1;
        fi = fi * -1;
    }

//    fval = modf( fi, &ival );
    ival = (double)(int)fi;
    fval = fi - ival;
    ft = (_FPF_ECALC_LONG_TYPE)(fval * 2);
    it = (_FPF_ECALC_LONG_TYPE)ival;
    if( ft & 0x01 ){
        ival += 1;
        if( fval == 0.5 && !(it & 0x01) ){
            ival -= 1;
        }
    }
    fi = ival;
    if( sign == 1 ){
        fi = fi * -1;
    }
    return fi;
}

// ceil
static double _fpf_DoubleRndCeilingLong( double fi )
{
    double dtmp;
    _FPF_ECALC_LONG_TYPE itmp;

    dtmp = fi;
    itmp = (_FPF_ECALC_LONG_TYPE)fi;

    dtmp = dtmp - itmp;
    if( dtmp != 0 ){
        itmp += 1;
    }
    
    return (double)itmp;
}

// floor
static double _fpf_DoubleRndFloorLong( double fi )
{
    _FPF_ECALC_LONG_TYPE  itmp;

    itmp = (_FPF_ECALC_LONG_TYPE)fi;
    return (double)itmp;
}


//
// doubleɕϊ
//
static double _fpf_to_double_long(
            _FPF_ECALC_LONG_TYPE fi, int ec_mode, int f_w, int ec_w )
{
    double dfi = fi;

    if( ec_mode == 2 ){
        dfi = dfi * (_FPF_ECALC_LONG_0x01 << ec_w );
    } else {
        dfi = dfi / (_FPF_ECALC_LONG_0x01 << f_w);
        dfi = dfi / (_FPF_ECALC_LONG_0x01 << ec_w);
    }
    return dfi;
}

//
// 
//
static float _fpf_to_float_long(
        _FPF_ECALC_LONG_TYPE fi, int ec_mode, int f_w, int ec_w )
{
    float dfi = fi;

    if( ec_mode == 2 ){
        dfi = dfi * (_FPF_ECALC_LONG_0x01 << ec_w );
    } else {
        dfi = dfi / (_FPF_ECALC_LONG_0x01 << f_w);
        dfi = dfi / (_FPF_ECALC_LONG_0x01 << ec_w);
    }
    return dfi;
}

static _FPF_ECALC_LONG_TYPE _fpf_to_fixed_long(
            double fi, int ec_mode, int f_w, int ec_w, int rnd_mode )
{
    if( ec_mode == 2 ){
        fi = fi / (_FPF_ECALC_LONG_0x01 << ec_w);
        return (_FPF_ECALC_LONG_TYPE)fi;
    }

    fi = fi * (_FPF_ECALC_LONG_0x01 << ec_w);
    fi = fi * (_FPF_ECALC_LONG_0x01 << f_w);

    if( rnd_mode == 0 ){
        // ؎̂
        fi = _fpf_DoubleRndTranLong( fi );
    } else if( rnd_mode == 1 ){
        // 0̂P
        fi = _fpf_DoubleRndRndLong( fi );
    } else if( rnd_mode == 2 ){
        // ۂ
        fi = _fpf_DoubleRndEvenLong( fi );
    } else if( rnd_mode == 3 ){
        fi = _fpf_DoubleRndCeilingLong( fi );
    } else {
        fi = _fpf_DoubleRndFloorLong( fi );
    }
    return (_FPF_ECALC_LONG_TYPE)fi;
}

#endif

#endif

