/*
 * RCS info: $Source: /export/work/usr/CVS_DB/FP-Fixer/src/cmd/pfl2dsp2_2_08/dsp_mul.h,v $
 *           $Revision: 1.2 $
 *           $Date: 2009/11/26 02:36:47 $
 *           $Author: haru $
 *           $Log: dsp_mul.h,v $
 *           Revision 1.2  2009/11/26 02:36:47  haru
 *           *** empty log message ***
 *
 *           Revision 1.4  2009/11/22 05:57:47  haru
 *           *** empty log message ***
 *
 *           Revision 1.3  2009/09/14 00:27:25  haru
 *
 *           (1)dsp_mul.h -> LONGLONG define delete
 *           (2)minus(-x) -> add bit mask
 *
 *           Revision 1.2  2009/09/07 01:08:32  haru
 *
 *           Chk. rnd_mode e and r
 *
 *           Revision 1.1  2009/08/11 06:28:02  haru
 *           *** empty log message ***
 *
 *
 * Copyright (c) 2009 ISHIZUE Design Automation Corp.
 */

/*============================================================================
 * 쐬F
 * 쐬ҁF
 * t@CFdsp_mul.h
 * Tv  FZlZ
 *==========================================================================*/

#ifndef _FPF_LEFTMUL
#define _FPF_LEFTMUL

#ifdef __FPF_MAX_16BIT
#define MUL32_CALC_BIT      8
#define MUL32_CALC_MASK_HI  0x00ffU
#define MUL32_CALC_MASK_LOW 0xff00U
#define MUL32_CALC_MASK_ALL 0xffffU
#else
#define MUL32_CALC_BIT      16
#define MUL32_CALC_MASK_HI  0x0000ffffU
#define MUL32_CALC_MASK_LOW 0xffff0000U
#define MUL32_CALC_MASK_ALL 0xffffffffU
#endif

#ifdef _FPF_LEFT_MUL_LONGLONG
#ifdef __FPF_MAX_16BIT
#define MUL64_CALC_TYPE     long
#define MUL64_CALC_BIT      16
#define MUL64_CALC_MASK_HI  0x0000ffffLU
#define MUL64_CALC_MASK_LOW 0xffff0000LU
#define MUL64_CALC_MASK_ALL 0xffffffffLU
#define MUL64_CALC_0x01     1LU
#else
#define MUL64_CALC_TYPE     long long
#define MUL64_CALC_BIT      32
#define MUL64_CALC_MASK_HI  0x00000000ffffffffLLU
#define MUL64_CALC_MASK_LOW 0xffffffff00000000LLU
#define MUL64_CALC_MASK_ALL 0xffffffffffffffffLLU
#define MUL64_CALC_0x01     1LLU
#endif
#endif

//
// lߏZ
//

#ifdef _FPF_LEFT_MUL_LONGLONG
static unsigned MUL64_CALC_TYPE _FPFSIM_mulLeftCalcCom64(
    unsigned MUL64_CALC_TYPE a, unsigned MUL64_CALC_TYPE b,
    int dw, int rnd_mode )
{
    unsigned MUL64_CALC_TYPE a_buf[5] = { 0, 0, 0, 0, 0 };
    unsigned MUL64_CALC_TYPE b_buf[5] = { 0, 0, 0, 0, 0 };
    unsigned MUL64_CALC_TYPE result_buf[9] = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
    int i, j;
    unsigned MUL64_CALC_TYPE y = 0;
    int w = MUL64_CALC_BIT;
    int ddw = 0;
    int sw = 0;

    for( i = 0; i < 4; i++ ){
        a_buf[i] = a & MUL64_CALC_MASK_HI;
        b_buf[i] = b & MUL64_CALC_MASK_HI;
        a >>= MUL64_CALC_BIT;
        b >>= MUL64_CALC_BIT;
    }

    a_buf[i] = a;
    a_buf[i] = b;

    // Z
    for( i = 0; i < 5; i++ ){
        for( j = 0; j < 5; j++ ){
            result_buf[i+j] += a_buf[i] * b_buf[j];
        }
    }

    // オ
    for( i = 0; i < 8; i++ ){
        result_buf[i+1] +=
                (result_buf[i] & MUL64_CALC_MASK_LOW) >> MUL64_CALC_BIT;
        result_buf[i] &= MUL64_CALC_MASK_HI;
    }

    y = 0;
    w = MUL64_CALC_BIT;
    ddw = dw;
    sw = 0;
    for( i = 0; i < 9; i++ ){
        if( sw == 0 ){
            if( dw <= w ){
                int rnd_sw = 0;
                // ۂߊmF
                if( rnd_mode == 1 || rnd_mode == 2 ){
                    if( i != 0 || ddw != 0 ){
                        if( ddw > 0 ){
                            rnd_sw = result_buf[i]
                                        & (MUL64_CALC_0x01 << (ddw-1));
                            if( rnd_mode == 2 && rnd_sw != 0 ){
                                // ۂ
                                unsigned long long mask;
                                int rnd_sw2 = 0;
                                int j;
                                mask = ~(MUL64_CALC_MASK_ALL << (ddw-1));
                                for( j = i; j >= 0; j-- ){
                                    if( result_buf[j] & mask ){
                                        rnd_sw2 = 1;
                                        break;
                                    }
                                    mask = MUL64_CALC_MASK_HI;
                                }
                                if( !rnd_sw2 ){
                                    if( ddw == MUL64_CALC_BIT ){
                                        rnd_sw = result_buf[i+1] & 0x01;
                                    } else {
                                        rnd_sw = result_buf[i]
                                                    & (MUL64_CALC_0x01<<ddw);
                                    }
                                }
                            }
                        } else {
                            rnd_sw = result_buf[i-1]
                                    & (MUL64_CALC_0x01<<(MUL64_CALC_BIT-1));
                            if( rnd_mode == 2 && rnd_sw != 0 ){
                                // ۂ
                                unsigned long long mask;
                                int rnd_sw2 = 0;
                                int j;
                                mask = ~(MUL64_CALC_MASK_ALL<<(MUL64_CALC_BIT-1));
                                for( j = i-1; j >= 0; j-- ){
                                    if( result_buf[j] & mask ){
                                        rnd_sw2 = 1;
                                        break;
                                    }
                                    mask = MUL64_CALC_MASK_HI;
                                }
                                if( !rnd_sw2 ){
                                    rnd_sw = result_buf[i] & 0x01;
                                }
                            }
                        }
                    }
                }

                y = result_buf[i] >> ddw;
                if( rnd_sw != 0 ){
                    y = y + 1;  // ۂ
                }
                w = MUL64_CALC_BIT - ddw; ;
                sw = 1;
            } else {
                ddw -= MUL64_CALC_BIT;
                w += MUL64_CALC_BIT;
            }
        } else {
            y = y + (result_buf[i] << w);
            w += MUL64_CALC_BIT;
        }
    }
    return y;
}

// l64rbg unsigned * unsigned
static unsigned MUL64_CALC_TYPE _FPFSIM_mulLeftCalcUU64(
    unsigned MUL64_CALC_TYPE a, unsigned MUL64_CALC_TYPE b,
    int dw, int rnd_mode )
{
    unsigned MUL64_CALC_TYPE y;

    y = _FPFSIM_mulLeftCalcCom64( a, b, dw, rnd_mode );
    return y;
}

// l64rbg unsigned * signed
static MUL64_CALC_TYPE _FPFSIM_mulLeftCalcUS64(
        unsigned MUL64_CALC_TYPE a, MUL64_CALC_TYPE b, int dw, int rnd_mode )
{
    int b_sgnd = 0;
    MUL64_CALC_TYPE y;

    if( b < 0 ){
        b = -b;
        b_sgnd = 1;
    }

    y = _FPFSIM_mulLeftCalcCom64( a, b, dw, rnd_mode );

    if( b_sgnd == 1 ){
        y = -y;
    }
    return y;
}

// l64rbg signed * unsigned
static MUL64_CALC_TYPE _FPFSIM_mulLeftCalcSU64(
    MUL64_CALC_TYPE a, unsigned MUL64_CALC_TYPE b, int dw, int rnd_mode )
{
    int a_sgnd = 0;
    MUL64_CALC_TYPE y;

    if( a < 0 ){
        a = -a;
        a_sgnd = 1;
    }

    y = _FPFSIM_mulLeftCalcCom64( a, b, dw, rnd_mode );

    if( a_sgnd == 1 ){
        y = -y;
    }
    return y;
}

// l64rbg signed * signed
static MUL64_CALC_TYPE _FPFSIM_mulLeftCalcSS64(
            MUL64_CALC_TYPE a, MUL64_CALC_TYPE b, int dw, int rnd_mode )
{
    int a_sgnd = 0;
    int b_sgnd = 0;
    MUL64_CALC_TYPE y;

    if( a < 0 ){
        a = -a;
        a_sgnd = 1;
    }
    if( b < 0 ){
        b = -b;
        b_sgnd = 1;
    }

    y = _FPFSIM_mulLeftCalcCom64( a, b, dw, rnd_mode );

    if( a_sgnd == 1 && b_sgnd == 0 ){
        y = -y;
    } else if( a_sgnd == 0 && b_sgnd == 1 ){
        y = -y;
    }
    return y;
}
#endif

//
//
//
static unsigned int _FPFSIM_mulLeftCalcCom32(
            unsigned int a, unsigned int b, int dw, int rnd_mode )
{
    unsigned int a_buf[5] = { 0, 0, 0, 0, 0 };
    unsigned int b_buf[5] = { 0, 0, 0, 0, 0 };
    unsigned int result_buf[9] = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
    int i, j;
    unsigned int y = 0;
    int w = MUL32_CALC_BIT;
    int ddw = 0;
    int sw = 0;

    for( i = 0; i < 4; i++ ){
        a_buf[i] = a & MUL32_CALC_MASK_HI;
        b_buf[i] = b & MUL32_CALC_MASK_HI;
        a >>= MUL32_CALC_BIT;
        b >>= MUL32_CALC_BIT;
    }

    a_buf[i] = a;
    a_buf[i] = b;

    // Z
    for( i = 0; i < 5; i++ ){
        for( j = 0; j < 5; j++ ){
            result_buf[i+j] += a_buf[i] * b_buf[j];
        }
    }

    // オ
    for( i = 0; i < 8; i++ ){
        result_buf[i+1] += (result_buf[i] & MUL32_CALC_MASK_LOW)
                                                >> MUL32_CALC_BIT;
        result_buf[i] &= MUL32_CALC_MASK_HI;
    }

    y = 0;
    w = MUL32_CALC_BIT;
    ddw = dw;
    sw = 0;
    for( i = 0; i < 9; i++ ){
        if( sw == 0 ){
            if( dw <= w ){
                int rnd_sw = 0;
                // ۂߊmF
                if( rnd_mode == 1 || rnd_mode == 2 ){
                    if( i != 0 || ddw != 0 ){
                        if( ddw > 0 ){
                            rnd_sw = result_buf[i] & (1U << (ddw-1));
                            if( rnd_mode == 2 && rnd_sw != 0 ){
                                // ۂ
                                unsigned int mask;
                                int rnd_sw2 = 0;
                                int j;
                                mask = ~(MUL32_CALC_MASK_ALL << (ddw-1));
                                for( j = i; j >= 0; j-- ){
                                    if( result_buf[j] & mask ){
                                        rnd_sw2 = 1;
                                        break;
                                    }
                                    mask = MUL32_CALC_MASK_HI;
                                }
                                if( !rnd_sw2 ){
                                    if( ddw == MUL32_CALC_BIT ){
                                        rnd_sw = result_buf[i+1] & 0x01;
                                    } else {
                                        rnd_sw = result_buf[i] & (1U<<ddw);
                                    }
                                }
                            }
                        } else {
                            rnd_sw = result_buf[i-1]&(1U<<(MUL32_CALC_BIT-1));
                            if( rnd_mode == 2 && rnd_sw != 0 ){
                                // ۂ
                                unsigned int mask;
                                int rnd_sw2 = 0;
                                int j;
                                mask = ~(MUL32_CALC_MASK_ALL<<(MUL32_CALC_BIT-1));
                                for( j = i-1; j >= 0; j-- ){
                                    if( result_buf[j] & mask ){
                                        rnd_sw2 = 1;
                                        break;
                                    }
                                    mask = MUL32_CALC_MASK_HI;
                                }
                                if( !rnd_sw2 ){
                                    rnd_sw = result_buf[i] & 0x01;
                                }
                            }
                        }
                    }
                }

                y = result_buf[i] >> ddw;
                if( rnd_sw != 0 ){
                    y = y + 1;  // ۂ
                }

                w = MUL32_CALC_BIT - ddw; ;
                sw = 1;
            } else {
                ddw -= MUL32_CALC_BIT;
                w += MUL32_CALC_BIT;
            }
        } else {
            y = y + (result_buf[i] << w);
            w += MUL32_CALC_BIT;
        }
    }
    return y;
}

// l32rbg unssigned * unsigned
static unsigned int _FPFSIM_mulLeftCalcUU32(
                unsigned int a, unsigned int b, int dw, int rnd_mode )
{
    unsigned int y;

    y = _FPFSIM_mulLeftCalcCom32( a, b, dw, rnd_mode );

    return y;
}

// l32rbg unssigned * signed
static int _FPFSIM_mulLeftCalcUS32(
            unsigned int a, int b, int dw, int rnd_mode )
{
    int b_sgnd = 0;
    int y;

    if( b < 0 ){
        b = -b;
        b_sgnd = 1;
    }

    y = _FPFSIM_mulLeftCalcCom32( a, b, dw, rnd_mode );

    if( b_sgnd == 1 ){
        y = -y;
    }
    return y;
}

// l32rbg signed * unsigned
static int _FPFSIM_mulLeftCalcSU32(
            int a, unsigned int b, int dw, int rnd_mode )
{
    int a_sgnd = 0;
    int y;

    if( a < 0 ){
        a = -a;
        a_sgnd = 1;
    }

    y = _FPFSIM_mulLeftCalcCom32( a, b, dw, rnd_mode );

    if( a_sgnd == 1 ){
        y = -y;
    }
    return y;
}

// l32rbg signed * signed
static int _FPFSIM_mulLeftCalcSS32( int a, int b, int dw, int rnd_mode )
{
    int a_sgnd = 0;
    int b_sgnd = 0;
    int y;

    if( a < 0 ){
        a = -a;
        a_sgnd = 1;
    }
    if( b < 0 ){
        b = -b;
        b_sgnd = 1;
    }

    y = _FPFSIM_mulLeftCalcCom32( a, b, dw, rnd_mode );

    if( a_sgnd == 1 && b_sgnd == 0 ){
        y = -y;
    } else if( a_sgnd == 0 && b_sgnd == 1 ){
        y = -y;
    }
    return y;
}

#endif

//
// 
//

