/*
 * RCS info: $Source: /export/work/usr/CVS_DB/FP-Fixer/src/cmd/pfl2dsp2_2_08/dsp_mul.h,v $
 *           $Revision: 1.2 $
 *           $Date: 2009/11/26 02:36:47 $
 *           $Author: haru $
 *           $Log: dsp_mul.h,v $
 *           Revision 1.2  2009/11/26 02:36:47  haru
 *           *** empty log message ***
 *
 *           Revision 1.4  2009/11/22 05:57:47  haru
 *           *** empty log message ***
 *
 *           Revision 1.3  2009/09/14 00:27:25  haru
 *
 *           (1)dsp_mul.h -> LONGLONG define delete
 *           (2)minus(-x) -> add bit mask
 *
 *           Revision 1.2  2009/09/07 01:08:32  haru
 *
 *           Chk. rnd_mode e and r
 *
 *           Revision 1.1  2009/08/11 06:28:02  haru
 *           *** empty log message ***
 *
 *
 * Copyright (c) 2009 ISHIZUE Design Automation Corp.
 */

/*============================================================================
 * 쐬F
 * 쐬ҁF
 * t@CFdsp_mul_dw.h
 * Tv  FZlZ
 *==========================================================================*/

#ifndef _FPF_DWORDMUL
#define _FPF_DWORDMUL

// #define _FPF_DWORD_MUL_LONGLONG

#ifdef __FPF_MAX_16BIT
#define _FPF_DWORD_MUL_INT_BITSIZE    16
#define _FPF_DWORD_MUL_INT_MASK       0xffffU
#define _FPF_DWORD_MUL_INT_SINBIT     0x8000U
#else
#define _FPF_DWORD_MUL_INT_BITSIZE    32
#define _FPF_DWORD_MUL_INT_MASK       0xffffffffU
#define _FPF_DWORD_MUL_INT_SINBIT     0x80000000U
#endif

#ifdef _FPF_DWORD_MUL_LONGLONG
#ifdef __FPF_MAX_16BIT
#define _FPF_DWORD_MUL_LONG2_BITSIZE   32
#define _FPF_DWORD_MUL_LONG2_TYPE      long
#define _FPF_DWORD_MUL_LONG2_MASK      0xffffffffLU
#define _FPF_DWORD_MUL_LONG2_0x01      0x01LU
#define _FPF_DWORD_MUL_LONG2_SINBIT    0x80000000LU
#else
#define _FPF_DWORD_MUL_LONG2_BITSIZE   64
#define _FPF_DWORD_MUL_LONG2_TYPE      long long
#define _FPF_DWORD_MUL_LONG2_MASK      0xffffffffffffffffLLU
#define _FPF_DWORD_MUL_LONG2_0x01      0x01LLU
#define _FPF_DWORD_MUL_LONG2_SINBIT    0x8000000000000000LLU
#endif
#endif



#ifdef _FPF_DWORD_MUL_LONGLONG

//
// DWORD 64 ۂߏ Floor
//
static _FPF_QWORD _fpf_Dword64x2Floor64(
    _FPF_QWORD qw, int sgnd, int f_w, int r_w )
{
    int w;

    if( f_w > r_w ){
        w = f_w - r_w;
        qw = _fpf_lshift128( qw, w );
    } else {
        qw = _fpf_lshift128( qw, r_w - f_w );
    }
    return qw;
}

//
// DWORD 64 ۂߏ Celling
//
static _FPF_QWORD _fpf_Dword64x2Ceil64(
    _FPF_QWORD qw, int sgnd, int f_w, int r_w )
{
    int w, af;
    unsigned long long iMask, iMask2;

    if( f_w > r_w ){
        w = f_w - r_w;
        af = 0;
        if( w < _FPF_DWORD_MUL_LONG2_BITSIZE ){
            iMask = _FPF_DWORD_MUL_LONG2_MASK << w;
            iMask2 = ~iMask;
            if( qw.dwLow & iMask2 ){
                af = 1;
            }
        } else if( w == _FPF_DWORD_MUL_LONG2_BITSIZE ){
            if( qw.dwLow & _FPF_DWORD_MUL_LONG2_MASK ){
                af = 1;
            }
        } else {
            iMask = _FPF_DWORD_MUL_LONG2_MASK << (w-_FPF_DWORD_MUL_LONG2_BITSIZE);
            iMask2 = ~iMask;
            if( (qw.dwHigh & iMask2) || qw.dwLow & _FPF_DWORD_MUL_LONG2_MASK ){
                af = 1;
            }
        }
        qw = _fpf_lshift128( qw, w );
        if( af ){
            qw.dwLow += 1;
        }
    } else {
        qw = _fpf_lshift128( qw, r_w - f_w );
    }
    return qw;
}

//
// DWORD 64 ۂߏ ۂ
//
static _FPF_QWORD _fpf_Dword64x2RndEven64(
        _FPF_QWORD qw, int sgnd, int f_w, int r_w )
{
    int w, af;
    long long iChkBit, iChkBit2;
    long long iMask;

    if( f_w > r_w ){
        if( sgnd ){
            qw = _fpf_NComp128( qw );
        }
        w = f_w - r_w;
        af = 0;
        if( w < _FPF_DWORD_MUL_LONG2_BITSIZE ){
            iMask = 0xffffffffffffffffULL << w;
            iChkBit = 0x01ULL << (w - 1) ;
            iChkBit2 = 0x01ULL << w ;

            if( qw.dwLow & iChkBit ){
                af = 1;
                if((qw.dwLow&(~iMask)) == iChkBit && !(qw.dwLow&iChkBit2)){
                    af = 0;
                }
            }
        } else if( w == _FPF_DWORD_MUL_LONG2_BITSIZE ){
            iMask = 0;
            iChkBit = _FPF_DWORD_MUL_LONG2_SINBIT;
            iChkBit2 = 0;
            if( qw.dwLow & _FPF_DWORD_MUL_LONG2_SINBIT ){
                af = 1;
                if((qw.dwLow&(_FPF_DWORD_MUL_LONG2_MASK)) == iChkBit
                                        && !qw.dwLow ){
                    af = 0;
                }
            }
        } else {
            iMask = _FPF_DWORD_MUL_LONG2_MASK << (w-_FPF_DWORD_MUL_LONG2_BITSIZE);
            iChkBit = 0x01ULL << (w-_FPF_DWORD_MUL_LONG2_BITSIZE-1) ;
            iChkBit2 = 0x01ULL << (w-_FPF_DWORD_MUL_LONG2_BITSIZE) ;
            
            if( qw.dwHigh & iChkBit ){
                af = 1;
                if((qw.dwHigh&(~iMask)) == iChkBit
                                && qw.dwLow == 0x0000000000000000ULL
                        && !(qw.dwHigh&iChkBit2) && !qw.dwLow ){
                    af = 0;
                }
            }
        }
        qw = _fpf_lshift128( qw, w );
        if( af ){
            qw.dwLow += 1;
        }
        if( sgnd ){
            qw = _fpf_NComp128( qw );
        }
    } else {
        qw = _fpf_lshift128( qw, r_w - f_w );
    }
    return qw;
}

//
// DWORD 64 ۂߏ ÔP
//
static _FPF_QWORD _fpf_Dword64x2Rnd64(
         _FPF_QWORD qw, int sgnd, int f_w, int r_w )
{
    int w, af;
    long long cb;
    long long iMask;

    if( f_w > r_w ){
        if( sgnd ){
            qw = _fpf_NComp128( qw );
        }
        w = f_w - r_w;
        af = 0;
        if( w < _FPF_DWORD_MUL_LONG2_BITSIZE ){
            cb = 0x01ULL << (w - 1) ;
            iMask = _FPF_DWORD_MUL_LONG2_MASK << w;
            if( qw.dwLow & cb ){
                af = 1;
            }
        } else if( w == _FPF_DWORD_MUL_LONG2_BITSIZE ){
            if( qw.dwLow & _FPF_DWORD_MUL_LONG2_SINBIT ){
                af = 1;
            }
        } else {
            iMask = _FPF_DWORD_MUL_LONG2_MASK << (w-_FPF_DWORD_MUL_LONG2_BITSIZE);
            cb = 0x01ULL << (w-_FPF_DWORD_MUL_LONG2_BITSIZE-1);
            if( qw.dwHigh & cb ){
                af = 1;
            }
        }

        qw = _fpf_lshift128( qw, w );
        if( af ){
            qw.dwLow += 1;
        }
        if( sgnd ){
            qw = _fpf_NComp128( qw );
        }
    } else {
        qw = _fpf_lshift128( qw, r_w - f_w );
    }
    return qw;
}

//
// DWORD 64 ۂߏ ؎̂
//
static _FPF_QWORD _fpf_Dword64x2Trn64(
         _FPF_QWORD qw, int sgnd, int f_w, int r_w )
{
    int w;
    _FPF_QWORD mask_dw;

    if( f_w > r_w ){
        if( sgnd == 1 ){
            // ۂߏ
            sgnd = 0;
            w = f_w - r_w;
            if( w < _FPF_DWORD_MUL_LONG2_BITSIZE ){
                mask_dw.dwLow = ~(_FPF_DWORD_MUL_LONG2_MASK << w);
                mask_dw.dwHigh = 0;
            } else {
                mask_dw.dwLow = _FPF_DWORD_MUL_LONG2_MASK;
                mask_dw.dwHigh = ~(_FPF_DWORD_MUL_LONG2_MASK << (w-64));
            }
            sgnd = qw.dwLow & mask_dw.dwLow;
            sgnd |= qw.dwHigh & mask_dw.dwHigh;
            qw = _fpf_rshift128( qw, f_w - r_w );
            if( sgnd ){
                qw.dwLow += 1;
            }
        } else {
            qw = _fpf_rshift128( qw, f_w - r_w );
        }
    } else {
        qw = _fpf_lshift128( qw, r_w - f_w );
    }
    return qw;
}

//
// DWORD 64rbg unssigned * unsigned
//
static int _FPFSIM_Mul64x2_UU64(
        unsigned long long a, unsigned long long b,
        int f_w, int r_w, int rnd_mode )
{
    _FPF_DWORD dw1;
    _FPF_DWORD dw2;
    _FPF_QWORD qw;

    dw1.dwHigh = a >> 32;
    dw1.dwLow = a;
    dw2.dwHigh = b >> 32;
    dw2.dwLow = b;

    qw = _fpf_Mul128( dw1, dw2 );
    if( rnd_mode == 0 ){    // 
        qw = _fpf_Dword64x2Trn64( qw, 0, f_w, r_w );
    } else if( rnd_mode == 1 ){
        qw = _fpf_Dword64x2Rnd64( qw, 0, f_w, r_w );
    } else if( rnd_mode == 2 ){
        qw = _fpf_Dword64x2RndEven64( qw, 0, f_w, r_w );
    } else if( rnd_mode == 3 ){
        qw = _fpf_Dword64x2Ceil64( qw, 0, f_w, r_w );
    } else if( rnd_mode == 4 ){
        qw = _fpf_Dword64x2Floor64( qw, 0, f_w, r_w );
    } else {
        qw = _fpf_Dword64x2Trn64( qw, 0, f_w, r_w );
    }

    return qw.dwLow;
}

//
// DWORD 64rbg unssigned * signed
//
static int _FPFSIM_Mul64x2_US64(
        unsigned long long a, long long b, int f_w, int r_w, int rnd_mode )
{
    _FPF_DWORD dw1;
    _FPF_DWORD dw2;
    _FPF_QWORD qw;
    int b_sgnd = 0;

    dw1.dwHigh = a >> (_FPF_DWORD_MUL_LONG2_BITSIZE/2);
    dw1.dwLow = a;
    dw2.dwHigh = b >> (_FPF_DWORD_MUL_LONG2_BITSIZE/2);
    dw2.dwLow = b;

    if( b < 0 ){
        dw2.dwHigh = 0 - 1;
        b_sgnd = 1;
    }

    qw = _fpf_Mul128( dw1, dw2 );
    if( rnd_mode == 0 ){    // 
        qw = _fpf_Dword64x2Trn64( qw, b_sgnd, f_w, r_w );
    } else if( rnd_mode == 1 ){
        qw = _fpf_Dword64x2Rnd64( qw, b_sgnd, f_w, r_w );
    } else if( rnd_mode == 2 ){
        qw = _fpf_Dword64x2RndEven64( qw, b_sgnd, f_w, r_w );
    } else if( rnd_mode == 3 ){
        qw = _fpf_Dword64x2Ceil64( qw, b_sgnd, f_w, r_w );
    } else if( rnd_mode == 4 ){
        qw = _fpf_Dword64x2Floor64( qw, b_sgnd, f_w, r_w );
    } else {
        qw = _fpf_Dword64x2Trn64( qw, b_sgnd, f_w, r_w );
    }

    return qw.dwLow;
}

//
// DWORD 64rbg signed * unsigned
//
static int _FPFSIM_Mul64x2_SU64(
        long long a, unsigned long long b, int f_w, int r_w, int rnd_mode )
{
    _FPF_DWORD dw1;
    _FPF_DWORD dw2;
    _FPF_QWORD qw;
    int a_sgnd = 0;

    dw1.dwHigh = a >> (_FPF_DWORD_MUL_LONG2_BITSIZE/2);
    dw1.dwLow = a;
    dw2.dwHigh = b >> (_FPF_DWORD_MUL_LONG2_BITSIZE/2);
    dw2.dwLow = b;

    if( a < 0 ){
        dw1.dwHigh = 0 - 1;
        a_sgnd = 1;
    }

    qw = _fpf_Mul128( dw1, dw2 );
    if( rnd_mode == 0 ){    // 
        qw = _fpf_Dword64x2Trn64( qw, a_sgnd, f_w, r_w );
    } else if( rnd_mode == 1 ){
        qw = _fpf_Dword64x2Rnd64( qw, a_sgnd, f_w, r_w );
    } else if( rnd_mode == 2 ){
        qw = _fpf_Dword64x2RndEven64( qw, a_sgnd, f_w, r_w );
    } else if( rnd_mode == 3 ){
        qw = _fpf_Dword64x2Ceil64( qw, a_sgnd, f_w, r_w );
    } else if( rnd_mode == 4 ){
        qw = _fpf_Dword64x2Floor64( qw, a_sgnd, f_w, r_w );
    } else {
        qw = _fpf_Dword64x2Trn64( qw, a_sgnd, f_w, r_w );
    }

    return qw.dwLow;
}

//
// DWORD 64rbg signed * signed
//
static int _FPFSIM_Mul64x2_SS64(
            long long a, long long b, int f_w, int r_w, int rnd_mode )
{
    _FPF_DWORD dw1;
    _FPF_DWORD dw2;
    _FPF_QWORD qw;

    int a_sgnd = 0;
    int b_sgnd = 0;
    int r_sgnd = 0;

    dw1.dwHigh = a >> (_FPF_DWORD_MUL_LONG2_BITSIZE/2);
    dw1.dwLow = a;
    dw2.dwHigh = b >> (_FPF_DWORD_MUL_LONG2_BITSIZE/2);
    dw2.dwLow = b;

    if( a < 0 ){
        dw1.dwHigh = 0 - 1;
        a_sgnd = 1;
    }
    if( b < 0 ){
        dw2.dwHigh = 0 - 1;
        b_sgnd = 1;
    }

    if( a_sgnd == 1 && b_sgnd == 0 ){
        r_sgnd = 1;
    } else if( a_sgnd == 0 && b_sgnd == 1 ){
        r_sgnd = 1;
    }

    qw = _fpf_Mul128( dw1, dw2 );
    if( rnd_mode == 0 ){    // 
        qw = _fpf_Dword64x2Trn64( qw, r_sgnd, f_w, r_w );
    } else if( rnd_mode == 1 ){
        qw = _fpf_Dword64x2Rnd64( qw, r_sgnd, f_w, r_w );
    } else if( rnd_mode == 2 ){
        qw = _fpf_Dword64x2RndEven64( qw, r_sgnd, f_w, r_w );
    } else if( rnd_mode == 3 ){
        qw = _fpf_Dword64x2Ceil64( qw, r_sgnd, f_w, r_w );
    } else if( rnd_mode == 4 ){
        qw = _fpf_Dword64x2Floor64( qw, r_sgnd, f_w, r_w );
    } else {
        qw = _fpf_Dword64x2Trn64( qw, r_sgnd, f_w, r_w );
    }

    return qw.dwLow;
}

#endif


//
// DWORD ۂߏ Floor
//
static _FPF_DWORD _fpf_Dword32x2Floor32(
    _FPF_DWORD qw, int sgnd, int f_w, int r_w )
{
    int w;

    if( f_w > r_w ){
        w = f_w - r_w;
        qw = _fpf_lshift64( qw, w );
    } else {
        qw = _fpf_lshift64( qw, r_w - f_w );
    }
    return qw;
}

//
// DWORD ۂߏ Celling
//
static _FPF_DWORD _fpf_Dword32x2Ceil32(
    _FPF_DWORD qw, int sgnd, int f_w, int r_w )
{
    int w, af;
    int iMask, iMask2;

    if( f_w > r_w ){
        w = f_w - r_w;
        af = 0;
        if( w < _FPF_DWORD_MUL_INT_BITSIZE ){
            iMask = _FPF_DWORD_MUL_INT_MASK << w;
            iMask2 = ~iMask;
            if( qw.dwLow & iMask2 ){
                af = 1;
            }
        } else if( w == _FPF_DWORD_MUL_INT_BITSIZE ){
            if( qw.dwLow & _FPF_DWORD_MUL_INT_MASK ){
                af = 1;
            }
        } else {
            iMask = _FPF_DWORD_MUL_INT_MASK << (w-_FPF_DWORD_MUL_INT_BITSIZE);
            iMask2 = ~iMask;
            if( (qw.dwHigh & iMask2) || qw.dwLow & _FPF_DWORD_MUL_INT_MASK ){
                af = 1;
            }
        }
        qw = _fpf_lshift64( qw, w );
        if( af ){
            qw.dwLow += 1;
        }
    } else {
        qw = _fpf_lshift64( qw, r_w - f_w );
    }
    return qw;
}

//
// DWORD ۂߏ ۂ
//
static _FPF_DWORD _fpf_Dword32x2RndEven32(
        _FPF_DWORD qw, int sgnd, int f_w, int r_w )
{
    int w, af;
    int iChkBit, iChkBit2;
    int iMask;

    if( f_w > r_w ){
        if( sgnd ){
            qw = _fpf_NComp64( qw );
        }
        w = f_w - r_w;
        af = 0;
        if( w < _FPF_DWORD_MUL_INT_BITSIZE ){
            iMask = _FPF_DWORD_MUL_INT_MASK << w;
            iChkBit = 0x01U << (w - 1) ;
            iChkBit2 = 0x01U << w ;

            if( qw.dwLow & iChkBit ){
                af = 1;
                if((qw.dwLow&(~iMask)) == iChkBit && !(qw.dwLow&iChkBit2)){
                    af = 0;
                }
            }
        } else if( w == _FPF_DWORD_MUL_INT_BITSIZE ){
            iMask = 0;
            iChkBit = _FPF_DWORD_MUL_INT_SINBIT;
            iChkBit2 = 0;
            if( qw.dwLow & _FPF_DWORD_MUL_INT_SINBIT ){
                af = 1;
                if((qw.dwLow&(_FPF_DWORD_MUL_INT_MASK)) == iChkBit && !qw.dwLow ){
                    af = 0;
                }
            }
        } else {
            iMask = 0xffffffffU << (w-_FPF_DWORD_MUL_INT_BITSIZE);
            iChkBit = 0x01U << (w-_FPF_DWORD_MUL_INT_BITSIZE-1) ;
            iChkBit2 = 0x01U << (w-_FPF_DWORD_MUL_INT_BITSIZE) ;
            
            if( qw.dwHigh & iChkBit ){
                af = 1;
                if((qw.dwHigh&(~iMask)) == iChkBit && qw.dwLow == 0x00000000U
                        && !(qw.dwHigh&iChkBit2) && !qw.dwLow ){
                    af = 0;
                }
            }
        }
        qw = _fpf_lshift64( qw, w );
        if( af ){
            qw.dwLow += 1;
        }
        if( sgnd ){
            qw = _fpf_NComp64( qw );
        }
    } else {
        qw = _fpf_lshift64( qw, r_w - f_w );
    }
    return qw;
}

//
// DWORD ۂߏ ÔP
//
static _FPF_DWORD _fpf_Dword32x2Rnd32(
         _FPF_DWORD qw, int sgnd, int f_w, int r_w )
{
    int w, af;
    int cb;
    int iMask;

    if( f_w > r_w ){
        if( sgnd ){
            qw = _fpf_NComp64( qw );
        }
        w = f_w - r_w;
        af = 0;
        if( w < _FPF_DWORD_MUL_INT_BITSIZE ){
            cb = 0x01U << (w - 1) ;
            iMask = _FPF_DWORD_MUL_INT_MASK << w;
            if( qw.dwLow & cb ){
                af = 1;
            }
        } else if( w == _FPF_DWORD_MUL_INT_BITSIZE ){
            if( qw.dwLow & _FPF_DWORD_MUL_INT_SINBIT ){
                af = 1;
            }
        } else {
            int iMask = _FPF_DWORD_MUL_INT_MASK << (w-_FPF_DWORD_MUL_INT_BITSIZE);
            int cb = 0x01U << (w-_FPF_DWORD_MUL_INT_BITSIZE-1);
            if( qw.dwHigh & cb ){
                af = 1;
            }
        }

        qw = _fpf_lshift64( qw, w );
        if( af ){
            qw.dwLow += 1;
        }
        if( sgnd ){
            qw = _fpf_NComp64( qw );
        }
    } else {
        qw = _fpf_lshift64( qw, r_w - f_w );
    }
    return qw;
}

//
// DWORD ۂߏ ؎̂
//
static _FPF_DWORD _fpf_Dword32x2Trn32(
         _FPF_DWORD qw, int sgnd, int f_w, int r_w )
{
    int w;
    _FPF_DWORD mask_dw;

    if( f_w > r_w ){
        if( sgnd == 1 ){
            // ۂߏ
            sgnd = 0;
            w = f_w - r_w;
            if( w < _FPF_DWORD_MUL_INT_BITSIZE ){
                mask_dw.dwLow = ~(_FPF_DWORD_MUL_INT_MASK << w);
                mask_dw.dwHigh = 0;
            } else {
                mask_dw.dwLow = _FPF_DWORD_MUL_INT_MASK;
                mask_dw.dwHigh = ~(_FPF_DWORD_MUL_INT_MASK << (w-_FPF_DWORD_MUL_INT_BITSIZE));
            }
            sgnd = qw.dwLow & mask_dw.dwLow;
            sgnd |= qw.dwHigh & mask_dw.dwHigh;
            qw = _fpf_rshift64( qw, f_w - r_w );
            if( sgnd ){
                qw.dwLow += 1;
            }
        } else {
            qw = _fpf_rshift64( qw, f_w - r_w );
        }
    } else {
        qw = _fpf_lshift64( qw, r_w - f_w );
    }
    return qw;
}


//
// DWORD 32rbg unssigned * unsigned
//
static int _FPFSIM_Mul32x2_UU32(
        unsigned int a, unsigned int b, int f_w, int r_w, int rnd_mode )
{
    _FPF_DWORD dw1;
    _FPF_DWORD dw2;
    _FPF_DWORD qw;

    dw1.dwHigh = 0;
    dw1.dwLow = a;
    dw2.dwHigh = 0;
    dw2.dwLow = b;

    qw = _fpf_Mul64( dw1, dw2 );
    if( rnd_mode == 0 ){    // 
        qw = _fpf_Dword32x2Trn32( qw, 0, f_w, r_w );
    } else if( rnd_mode == 1 ){
        qw = _fpf_Dword32x2Rnd32( qw, 0, f_w, r_w );
    } else if( rnd_mode == 2 ){
        qw = _fpf_Dword32x2RndEven32( qw, 0, f_w, r_w );
    } else if( rnd_mode == 3 ){
        qw = _fpf_Dword32x2Ceil32( qw, 0, f_w, r_w );
    } else if( rnd_mode == 4 ){
        qw = _fpf_Dword32x2Floor32( qw, 0, f_w, r_w );
    } else {
        qw = _fpf_Dword32x2Trn32( qw, 0, f_w, r_w );
    }

    return qw.dwLow;
}

//
// DWORD 32rbg unssigned * signed
//
static int _FPFSIM_Mul32x2_US32(
        unsigned int a, int b, int f_w, int r_w, int rnd_mode )
{
    _FPF_DWORD dw1;
    _FPF_DWORD dw2;
    _FPF_DWORD qw;
    int b_sgnd = 0;

    dw1.dwHigh = 0;
    dw1.dwLow = a;
    dw2.dwHigh = 0;
    dw2.dwLow = b;

    if( b < 0 ){
        dw2.dwHigh = 0 - 1;
        b_sgnd = 1;
    }

    qw = _fpf_Mul64( dw1, dw2 );
    if( rnd_mode == 0 ){    // 
        qw = _fpf_Dword32x2Trn32( qw, b_sgnd, f_w, r_w );
    } else if( rnd_mode == 1 ){
        qw = _fpf_Dword32x2Rnd32( qw, b_sgnd, f_w, r_w );
    } else if( rnd_mode == 2 ){
        qw = _fpf_Dword32x2RndEven32( qw, b_sgnd, f_w, r_w );
    } else if( rnd_mode == 3 ){
        qw = _fpf_Dword32x2Ceil32( qw, b_sgnd, f_w, r_w );
    } else if( rnd_mode == 4 ){
        qw = _fpf_Dword32x2Floor32( qw, b_sgnd, f_w, r_w );
    } else {
        qw = _fpf_Dword32x2Trn32( qw, b_sgnd, f_w, r_w );
    }

    return qw.dwLow;
}


//
// DWORD 32rbg signed * unsigned
//
static int _FPFSIM_Mul32x2_SU32(
        int a, unsigned int b, int f_w, int r_w, int rnd_mode )
{
    _FPF_DWORD dw1;
    _FPF_DWORD dw2;
    _FPF_DWORD qw;
    int a_sgnd = 0;

    dw1.dwHigh = 0;
    dw1.dwLow = a;
    dw2.dwHigh = 0;
    dw2.dwLow = b;

    if( a < 0 ){
        dw1.dwHigh = 0 - 1;
        a_sgnd = 1;
    }

    qw = _fpf_Mul64( dw1, dw2 );
    if( rnd_mode == 0 ){    // 
        qw = _fpf_Dword32x2Trn32( qw, a_sgnd, f_w, r_w );
    } else if( rnd_mode == 1 ){
        qw = _fpf_Dword32x2Rnd32( qw, a_sgnd, f_w, r_w );
    } else if( rnd_mode == 2 ){
        qw = _fpf_Dword32x2RndEven32( qw, a_sgnd, f_w, r_w );
    } else if( rnd_mode == 3 ){
        qw = _fpf_Dword32x2Ceil32( qw, a_sgnd, f_w, r_w );
    } else if( rnd_mode == 4 ){
        qw = _fpf_Dword32x2Floor32( qw, a_sgnd, f_w, r_w );
    } else {
        qw = _fpf_Dword32x2Trn32( qw, a_sgnd, f_w, r_w );
    }

    return qw.dwLow;
}


//
// DWORD 32rbg signed * signed
//
static int _FPFSIM_Mul32x2_SS32(
            int a, int b, int f_w, int r_w, int rnd_mode )
{
    _FPF_DWORD dw1;
    _FPF_DWORD dw2;
    _FPF_DWORD qw;

    int a_sgnd = 0;
    int b_sgnd = 0;
    int r_sgnd = 0;

    dw1.dwHigh = 0;
    dw1.dwLow = a;
    dw2.dwHigh = 0;
    dw2.dwLow = b;

    if( a < 0 ){
        dw1.dwHigh = 0 - 1;
        a_sgnd = 1;
    }
    if( b < 0 ){
        dw2.dwHigh = 0 - 1;
        b_sgnd = 1;
    }

    if( a_sgnd == 1 && b_sgnd == 0 ){
        r_sgnd = 1;
    } else if( a_sgnd == 0 && b_sgnd == 1 ){
        r_sgnd = 1;
    }

    qw = _fpf_Mul64( dw1, dw2 );
    if( rnd_mode == 0 ){    // 
        qw = _fpf_Dword32x2Trn32( qw, r_sgnd, f_w, r_w );
    } else if( rnd_mode == 1 ){
        qw = _fpf_Dword32x2Rnd32( qw, r_sgnd, f_w, r_w );
    } else if( rnd_mode == 2 ){
        qw = _fpf_Dword32x2RndEven32( qw, r_sgnd, f_w, r_w );
    } else if( rnd_mode == 3 ){
        qw = _fpf_Dword32x2Ceil32( qw, r_sgnd, f_w, r_w );
    } else if( rnd_mode == 4 ){
        qw = _fpf_Dword32x2Floor32( qw, r_sgnd, f_w, r_w );
    } else {
        qw = _fpf_Dword32x2Trn32( qw, r_sgnd, f_w, r_w );
    }

    return qw.dwLow;
}

#endif

//
// 
//

